<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    <script>
        var arrayFinal = []
        var puesto = 0
        var cadenaArray = []
        function transforma(cadena){
            arrayFinal = [];
            var cadenaSinEspacios = cadena.trim();
            var cadenaAyuda = cadenaSinEspacios.replace(/\./, '')
            cadenaAyuda = cadenaAyuda.replace(/\,/,'');
            var arrayAyuda = cadenaAyuda.split(' ');
            cadenaArray = cadenaSinEspacios.split(' ');
            for(var i = 0; i < arrayAyuda.length; i++){
                if(arrayAyuda[i].length > 3){
                    desorganiza(arrayAyuda[i]);
                }
                else{
                    arrayFinal.push(cadenaArray[i]);
                }
                puesto++;
            }
            return arrayFinal.join(' ');
        }
        function desorganiza(string) {
            var primera = string[0];
            var ultima = string[(string.length - 1)];
            console.log(1)
            do{
                var cadena = string.substr(1, (string.length - 2));
                var arrayLetras = cadena.split('');
                arrayLetras.sort(function(a, b){return 0.5 - Math.random()})
                var final = primera + arrayLetras.join('') + ultima;
            }  
            while(string === final);
            
            if(string != cadenaArray[puesto]){
                var palabra = cadenaArray[puesto]
                final += palabra[(palabra.length - 1)]
            }
            arrayFinal.push(final);
        }
        var adivinazasRealizadas = [false, false, false, false, false, false, false, false]
        var numero;
        var json;
        function Adivinanza(){
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function(){
                if(xhr.readyState == 4 && xhr.status == 200){
                    try{
                        json = JSON.parse(xhr.responseText)
                        TrabajaJSON(json)
                    }catch{
                        console.log('error');
                    }
                }
            }
            xhr.open("GET", "adivinanzas.json", true);
            xhr.send();
        }

        function TrabajaJSON(){
            numero = Math.floor(Math.random() * json.length);
            if(!adivinazasRealizadas[numero]){
                document.getElementById('adivinanza').innerHTML = "";
                for(var i = 0; i < json[numero].versos.length; i++){
                    document.getElementById('adivinanza').innerHTML += transforma(json[numero].versos[i]) + "<br>";
                }
                document.getElementById('adivinanza').innerHTML += "<button onclick='pista(numero)' id='pista'>Pista!!!</button>"
                document.getElementById('adivinanza').innerHTML += "<button onclick='solucion(numero)' id='solucion'>Ver Solución</button>"
                document.getElementById('adivinanza').style = "max-width: 200px; border: 3px solid black";
                adivinazasRealizadas[numero] = true;
            }
            else{
                var contador = 0;
                for(var i = 0; i < adivinazasRealizadas.length; i++){
                    if(adivinazasRealizadas[i]){
                        contador++;
                    }
                }
                if(contador == adivinazasRealizadas.length){
                    alert('ya has realizado todas las adivinanzas')
                    document.getElementById('boton').disabled = true;
                }else{
                    TrabajaJSON();
                }
                
            }
        }
        
        function pista(numero){
            alert(json[numero].pista);
            document.getElementById('pista').style = 'display:none;'
        }
        function solucion(numero){
            document.getElementById('adivinanza').innerHTML += "<p style='color: red; font-weight: bold; font-size: 15px;'>" + json[numero].solucion + "</p>";

            document.getElementById('solucion').style = 'display:none;'
            if(document.getElementById('pista').style != 'display:none;'){
                document.getElementById('pista').style = 'display:none;'
            }
        }
    </script>
</head>
<body>
    <h1>Recursos Educativos</h1>
    <h3>Adivinanzas Infantiles</h3>
    <button onclick="Adivinanza()" id="boton">Nueva Adivinanza</button>
    <div id="adivinanza"></div>
</body>
</html>